

#define CUSTOM_SETTINGS
#define INCLUDE_GAMEPAD_MODULE
#include <Dabble.h>
#include <MPU9250.h>

// define pins
const int trigPin = 5;
const int echoPin = 12;
const int motor1pin1 = 7;
const int motor1pin2 = 8;
const int motor2pin1 = 9;
const int motor2pin2 = 10;

MPU9250 mpu;

long duration;
int distance;
float speedm;
float speedm0;
int stats;
float acc;
int start_time;
int current_time;
int deviation;
int deviation_start_point;
void setup() {
  // senzor distanta
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  
  // serial 
  Serial.begin(250000);
  // bth
  Dabble.begin(9600);     

   // giroscop
    mpu.setup(0x68);

}

void loop() {
  Dabble.processInput();

  // clear pin trig de la senzor dist
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  
  // init de trig pin 
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  
  // read the echo pin
  duration = pulseIn(echoPin, HIGH);
  
  // calc dist
  distance= duration*0.034/2;
  
  // control motor
  if (distance > 10) {
    
    if (GamePad.isUpPressed())
    {
      deviation_start_point = mpu.getGyroBiasZ() / (float)MPU9250::CALIB_GYRO_SENSITIVITY;
      start_time = millis();
      Serial.print("move forward");
      digitalWrite(motor1pin1, HIGH);
      digitalWrite(motor2pin1, HIGH);
      
      acc = (mpu.getAccBiasX() * 1000.f / (float)MPU9250::CALIB_ACCEL_SENSITIVITY);
      Serial.print("Accel X: ");
      Serial.print(acc);
      current_time = millis();
      speedm = speedm0 + acc*(current_time - start_time);
      Serial.print("Speed X: ");
      Serial.print(speedm);
      speedm0 = speedm;
      deviation = mpu.getGyroBiasZ() / (float)MPU9250::CALIB_GYRO_SENSITIVITY;

      // devion due to uneven power distribution
      if(deviation_start_point - deviation > 10){ // derive to right
        digitalWrite(motor1pin1, LOW);
        digitalWrite(motor2pin1, HIGH);
        delay(10);
        digitalWrite(motor1pin1, HIGH);
        digitalWrite(motor2pin1, HIGH);
      }
      if(deviation_start_point - deviation < -10){ // derive to left
        digitalWrite(motor1pin1, HIGH);
        digitalWrite(motor2pin1, LOW);
        delay(10);
        digitalWrite(motor1pin1, HIGH);
        digitalWrite(motor2pin1, HIGH);
      }
    }

    if (GamePad.isDownPressed())
    {
      Serial.print("move in revere");
      digitalWrite(motor1pin2, HIGH);
      digitalWrite(motor2pin2, HIGH);
    
    }

    if (GamePad.isLeftPressed())
    {
      Serial.print("move to left");
      digitalWrite(motor2pin1, HIGH);
    }

    if (GamePad.isRightPressed())
    {
      Serial.print("move to right");
      digitalWrite(motor1pin1, HIGH);
    }
  } else {
      digitalWrite(motor1pin1, HIGH);
      digitalWrite(motor1pin2, LOW);
      digitalWrite(motor2pin1, LOW);
      digitalWrite(motor2pin2, LOW);
      delay(100);
      digitalWrite(motor1pin1, LOW);
      speedm0 = 0;
  };

  delay(1000);
}
